models/Contacto.php
<?php
namespace app\models;

use yii\base\Model;
use Yii;

class Contacto extends Model{
    public $nombre;
    public $email;
    public $telefono;
    public $direccion;
    public $asunto;
    public $fecha;
    public $politicas;
    
    public function attributeLabels(): array {
        return [
            "nombre" => "Nombre completo",
            "email" => "Correo electronico",
            "telefono" => "Telefono",
            "direccion" => "Dirreccion completa",
            "asunto" => "¿Cual es tu pregunta?",
            "fecha" => "Fecha de nacimiento",
            "politicas" => "Aceptar politicas de privacidad",
        ];
    }
    
    public function rules() {
        return [
            [["nombre","email","telefono"],"required"],
            ["email","email"],
            ["nombre","string","length"=>[1,100]],
            ["politicas",'boolean'],
            ["fecha","string"],
            //["fecha","date","format"=>'dd/mm/yyyy'],
            [["direccion","asunto"],"safe"],
            ["politicas","comprobarpoliticas"], // chequear si has aceptado las politicas
        ];
    }
    
    
    /**
     * chequear que hayas aceptado las politicas
     * 
     */
    public function comprobarpoliticas($attribute,$params) {
        if($this->$attribute==0){
            $this->addError($attribute,"Es necesario que aceptes las politicas de privacidad");
        }
    }
    
    
    public function contact()
    {
        if ($this->validate()) {
            Yii::$app->mailer->compose()
                ->setTo(Yii::$app->params['contacto'])
                ->setFrom([Yii::$app->params['senderEmail'] => Yii::$app->params['senderName']])
                ->setReplyTo([$this->email => $this->nombre])
                ->setSubject("contacto")
                ->setTextBody($this->asunto)
                ->send();

            return true;
        }
        return false;
    }

}

models/Productos.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "productos".
 *
 * @property int $id
 * @property string|null $nombre
 * @property string|null $foto
 * @property string|null $descripcion
 * @property float|null $precio
 * @property int|null $oferta
 * @property string|null $categorias
 */
class Productos extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'productos';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id'], 'required'],
            [['id', 'oferta'], 'integer'],
            [['precio'], 'number'],
            [['nombre', 'foto', 'categorias'], 'string', 'max' => 100],
            [['descripcion'], 'string', 'max' => 2000],
            [['id'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'nombre' => 'Nombre',
            'foto' => 'Foto',
            'descripcion' => 'Descripcion',
            'precio' => 'Precio',
            'oferta' => 'Oferta',
            'categorias' => 'Categorias',
        ];
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\ActiveDataProvider;
use app\models\Productos;
use yii\helpers\Html;
use yii\helpers\ArrayHelper;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContacto()
{
    $model = new \app\models\Contacto(); // objeto de tipo contacto
    //$datos=Yii::$app->request->post(); // leo todos los datos enviados y los coloco en $datos
    
    if ($model->load(Yii::$app->request->post())) {
        if ($model->contact()) {
                 return $this->render("mostrar");
        }
    }

    return $this->render('contacto', [
        'model' => $model,
    ]);
}
    
    
    public function actionOfertas() {
        $dataProvider = new ActiveDataProvider([
            "query" => Productos::find()->where(['oferta'=>1]),
        ]);
                
        return $this->render('oferta',[
            'dataProvider' => $dataProvider,
        ]);        
    }
    
    public function actionProductos() {
        $dataProvider = new ActiveDataProvider([
            "query" => Productos::find(),
            'pagination' => [
                'pageSize' => 2,
            ]
        ]);
                
        return $this->render('producto',[
            'dataProvider' => $dataProvider,
        ]);        
    }
    
    public function actionCategorias() {
        $dataProvider = new ActiveDataProvider([
            "query" => Productos::find()->select('categorias')->distinct(),
        ]);
                
        return $this->render('categorias',[
            'dataProvider' => $dataProvider,
        ]);        
    }
    
    public function actionVer($categoria) {
        $productos = Productos::find()->where(['categorias'=>$categoria]);
        
        $dataProvider= new ActiveDataProvider([
            'query' => $productos,
        ]);
        
        return $this->render('ver',[
            'dataProvider'=> $dataProvider,
            'categoria'=> $categoria,
        ]);
    }
    
    public function actionDonde() {
        
        return $this->render('donde');
    }
    
    public function actionSomos() {
        
        return $this->render('somos');
    }
    
    
    public function actionNuestros() {
        
        $fotos= Productos::find()
                ->select("foto")
                ->where(["oferta" => 1])
                ->asArray()
                ->all();
        
        $fotos= ArrayHelper::getColumn($fotos, "foto");
        
        $salida=[];
        foreach ($fotos as $src){
            $salida[]= Html::img("@web/imgs/$src");
        }
                
        return $this->render('nuestro',[
            "fotos" => $salida,
        ]);
    }
    
    public function actionInfo() {
        
        return $this->render('info');      
    }
    
    public function actionVermas($id) {
        
        // metodo 1
        //$salida=Productos::find()->where(["id"=>$id]);
       
        //metodo 2
        $salida= Productos::findOne($id);
        
        return $this->render("vermas",[
            "model" => $salida
        ]);
    }
    
}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'encodeLabels' => false,
        'items' => [
            ['label' => '<i class="fas fa-house-user"></i> Inicio', 'url' => ['/site/index']],
            ['label' => '<i class="fa fa-check" aria-hidden="true"> </i> Ofertas', 'url' => ['/site/ofertas']],
            ['label' => '<i class="fas fa-box-open"></i> Productos', 'url' => ['/site/productos']],
            ['label' => '<i class="fas fa-certificate"></i> Categorias', 'url' => ['/site/categorias']],
            ['label' => '<i class="fas fa-info-circle"></i> Nosotros', 'items' => [
            ['label' => 'Donde estamos', 'url' => ['/site/donde']],    
            ['label' => 'Quienes somos', 'url' => ['/site/somos']],
            ['label' => 'Nuestros productos', 'url' => ['/site/nuestros']],
            '<div class="dropdown-divider"></div>',
            ['label' => 'Informacion', 'url' => ['/site/info']]]],
            ['label' => '<i class="fas fa-id-card"></i> Contacto', 'url' => ['/site/contacto']],
            
        ],
    ]);
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container">
        <p class="float-left">Pedro J. Prueba 1 de YII</p>
        <p class="float-right">Alpe Formacion</p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/_categorias.php
<?php
use yii\helpers\Html;
?>

    
        <?= Html::a($model->categorias, 
                ['site/ver', 'categoria' => $model->categorias],
                ['class'=>'col-lg-12 d-block p-4 mb-5 btn btn-primary']) ?></li>
  </ul>

views/site/_oferta.php
<?php
use yii\helpers\Html;
?>
<div class="row">
    <div class="col-lg-5">
    <?php
    echo Html::img("@web/imgs/$model->foto",[
    "class" =>"img-fluid"
    ]);
    
    ?>
    </div>
    <div class="col-lg-7">
        <h2><?= $model->nombre ?><br></h2>
        <div class="bg-warning rounded p-2">Precio:</div>
        <div class="p-1"><?= $model->precio ?> </div>
        <div class="bg-warning rounded p-2">Descripcion:</div>
        <div class="p-1"><?= substr($model->descripcion,0,100) . "..." ?></div>
        <div class="bg-warning rounded p-2">Categoria:</div>
        <div class="p-1"><?= $model->categorias ?></div>
        <?= Html::a("Ver mas",["site/vermas", "id"=>$model->id],["class"=>"btn btn-primary float-right"]) ?>
        <br>
    </div>
    
</div>

views/site/_ver.php
<?php
use yii\helpers\Html;
?>
<div class="row">
    <div class="col-lg-5">
    <?php
    echo Html::img("@web/imgs/$model->foto",[
    "class" =>"card-img-top"
    ]);
    
    ?>
    </div>
    <div class="col-lg-7">
        <h2><?= $model->nombre ?><br></h2>
        <div class="bg-warning rounded p-2">Precio:</div>
        <div class="p-1"><?= $model->precio ?> </div>
        <div class="bg-warning rounded p-2">Descripcion:</div>
        <div class="p-1"><?= substr($model->descripcion,0,50) . "..." ?></div>
        <br>
        <?= Html::a("Ver mas",["site/vermas", "id"=>$model->id],["class"=>"btn btn-primary float-right"]) ?>
    </div>
    
</div>

views/site/categorias.php
<?php
use yii\widgets\ListView;
?>
<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">Categorias</h1>

<?php

echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView'=>'_categorias',
    'itemOptions'=>[
        'class'=>'col-lg-4'
        ],
    'options'=>[
        'class'=>'row'
        ],
    'layout'=>"{items}"
]);

?>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/* @var $this yii\web\View */

$this->title = 'Jota';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent">
        <h1 class="display-4">LA JOTA</h1>
    </div>

    <div class="body-content">

        <div class="row">
            <div class="col-lg-12 text-justify">
                <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.</p>
            </div>
        </div>

    </div>
</div>

views/site/info.php
<div class="site-index">
    <div class="jumbotron text-center bg-transparent">
        <h1 class="display-4">Informacion a destacar</h1>
    </div>

    <div class="body-content">

        <div class="row">
            <div class="col-lg-12 text-justify">
                <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.</p>
                    
            </div>
        </div>

    </div>
</div>

views/site/mostrar.php
Muchas gracias en breve nos pondremos en contacto.

views/site/nuestro.php
<?php
use yii\bootstrap4\Carousel;
use yii\helpers\Html;

echo Carousel::widget([
    'items' => $fotos,
    'options'=>[
        'class'=> 'mx-auto col-lg-8'
    ],
    'controls' => ['<i class="fas fa-arrow-left fa-3x"></i>','<i class="fas fa-arrow-right fa-3x"></i>']
]);

views/site/oferta.php
<?php
use yii\widgets\ListView;
?>
<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">
    Ofertas:
</h1>
<?php
echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView'=>'_oferta',
    "itemOptions" => [
        'class' => 'col-lg-5 ml-auto mr-auto bg-light p-3 mb-5',
    ],
    'options'=>[
        'class'=>'row'
        ],
    'layout'=>"{items}"
]);

views/site/producto.php
<?php

use yii\grid\GridView;
use yii\helpers\Html;
?>

<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">Listado de productos</h1>
<?php
echo GridView::widget([
    'dataProvider' => $dataProvider,
    'layout' => '{items}<br>{pager}<br>{summary}',
    "pager"=>[
        "options" => ["class"=>"row col-6"],
        "linkOptions"=>["class"=>"p-2 d-block w-100 h-100"],
        "disabledPageCssClass"=>"p-2 rounded d-block col-1 border",
        "activePageCssClass"=>"bg-light",
        "nextPageCssClass"=>"rounded d-block col-1 border",
        "prevPageCssClass"=>"rounded d-block col-1 border",
        "pageCssClass"=>"rounded d-block col-1 p-0 border",
    ],

    'columns' => [
        'id',
        'nombre',
        'precio',
        'categorias',
        [
            'attribute' => 'foto',
            'label'=>'foto',
            'format'=>'raw',
            'value' => function($data){
                $url = '@web/imgs/' . $data->foto;
                return Html::img($url,[
                    'class'=>'img-fluid mx-auto d-block',
                    'style'=> 'width:200px']); 
            }
        ],
        'descripcion',
        'oferta',
    ],
    'options'=>[
        'class' => 'text-center'
    ]            
]);
?>

views/site/somos.php
<div class="site-index">

    <div class="jumbotron text-center bg-transparent">
        <h1 class="display-4">Es el alcalde el que quiere que sean los vecinos el alcalde</h1>
    </div>

    <div class="body-content">

        <div class="row">
            <div class="col-lg-12 text-justify">
                <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.</p>
                    <h2 class="display-4 text-center">VIVA EL VINO</h2>
            </div>
        </div>

    </div>
</div>

views/site/ver.php
<?php
use yii\widgets\ListView;
?>
<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">
    Listado de Productos de Categoria <?= $categoria ?>
</h1>
<?php
echo ListView::widget([
    "dataProvider" => $dataProvider,
    "itemView" => "_ver",
    "itemOptions" => [
        'class' => 'col-lg-5 ml-auto mr-auto bg-light p-3 mb-5',
    ],
    "options" => [
        'class' => 'row',
    ],
    'layout'=>"{items}"
]);

views/site/vermas.php
<?php

use yii\widgets\DetailView;
use yii\helpers\Html;

echo DetailView::widget([
    'model' => $model,
    'attributes' => [
        'id',
        'nombre',
        'descripcion',
        'precio',
        'categoria',
        'oferta',
        [
            'attribute' => 'foto',
            'label'=>'foto',
            'format'=>'raw',
            'value' => function($data){
                $url = '@web/imgs/' . $data->foto;
                return Html::img($url,[
                    'class'=>'img-fluid mx-auto d-block',
                    'style'=> 'width:200px']); 
            }
        ],
    ],
]);